// ImageCount.cpp:      .
//

#include "stdafx.h"

int ROWS = 0; //  
int COLS = 0; //  

char *Field;

bool LoadImage(const char * name)
{   FILE* f = fopen(name,"rt");
	if (!f) return false;
	fscanf(f,"%d %d\n",&ROWS,&COLS);
	printf("ROWS=%d, COLS=%d\n",ROWS,COLS);
	Field = new char[ROWS*COLS];
	for (int i=0; i<ROWS; i++)
	{
      for (int j=0; j<COLS; j++)
	    Field[ROWS*i+j]=fgetc(f);
	    fgetc(f); 
	}

	return true;
}


void PrintField()
{
	for (int i=0; i<ROWS; i++)
	{
		for (int j=0; j<COLS; j++) putchar(Field[ROWS*i+j]);
		printf("\n");
	}
	printf("\n");
}

void KillObject(int i,int j)
{
	if (i>=ROWS || j>=COLS) return;
	if (Field[ROWS*i+j]!='*') return;
    Field[ROWS*i+j]='+';
	KillObject(i+1,j);
	KillObject(i,j+1);
	KillObject(i+1,j+1);
}

int _tmain(int argc, _TCHAR* argv[])
{   int n=0;
    if (LoadImage("image.txt"))
	{
		PrintField();
		for (int i=0; i<ROWS; i++)
			for (int j=0; j<COLS; j++)
				if (Field[ROWS*i+j]=='*')
				{
					n++;
					KillObject(i,j);
					PrintField();
					getchar();
				}
       printf("%d objects found\n",n);

	}
	else
		printf("File not found!\n");
	return 0;
}

