#include "stdafx.h"

void print(int *a, int n)
{
	for (int i=0; i<n; i++) printf("%5d",a[i]);
	printf("\n");
}

void fill(int a[], int n)
{
	for (int i=0; i<n; i++) a[i]=rand() % 10000;
}

void swap(int &x, int &y)
{
	int z=x; x=y; y=z;
}

int sort(int a[], int n)
{   // - ( ..)
	int L = 0, B = n-1; //   
	int f;
	int k=0; //   ( )

	while (1)
	{
		f=1;         // --------------->>>>
		for (int i=L; i<B; i++)
			if (a[i]>a[i+1]) { swap(a[i],a[i+1]); f=0; k++; }
		if (f) break;
        B--;   

		f=1; 		// <<<< ----------------
		for (int i=B-1; i>=L; i--)
			if (a[i]>a[i+1]) { swap(a[i],a[i+1]); f=0; k++; }
		if (f) break;
		L++;
        // printf("L=%d R=%d\n",L,B);	
	}

	return k;
}

int  qk = 0;

void QuickSort(int a[], int L, int R) 
{   int x; //    
    int l=L;
	int r=R;

	x=a[(L+R)/2];
	while (l<=r)
	{
		while (a[l]<x) l++;
		while (a[r]>x ) r--;
		if (l<=r) { swap(a[l],a[r]); qk++; l++; r--; }
	}
	if (L<r) QuickSort(a,L,r);
	if (l<R) QuickSort(a,l,R);
}

	
int _tmain(int argc, _TCHAR* argv[])
{
	const int N = 50000;
	int a[N];
	int k;
	srand(275);   //   
	fill(a,N);    //  
    k=sort(a,N);  //  
	printf("Shaker sort %d changes\n",k);
	// print(a,N);   //  

	fill(a,N);    
	QuickSort(a,0,N-1);
	printf("Quick Sort %d changes\n",qk);
    // print(a,N);   //  

	return 0;
}

